#!/bin/bash

#updates by WIBOON 2558-01-29, 2562-11-08

#Delete multiple users
#You can delete multiple users from PSU-netdrive file server from a single file source. The file must be a text file and adhere to the required format. 
#For example 
#Filename: usergroup1
#user1
#user2
#user3
#
#When finished, the original filename will be replace with a filename_timestamp.csv consists of lines with username:status format.

exitusage()
{
  echo "usage: sudo sh $0 path/to/filename"
  echo "path/to/filename is a file consists of one username per line i.e."
  echo "user1"
  echo "user2"
  exit 
}

if [ -z "$(id -nG|grep -w "root")" ] ; then
  echo "need root, or try: sudo sh $0"
  exit
fi
if [ "$1" = "--help" ] ; then
  exitusage
fi
if [ -z "$1" ] ; then
  echo "need filename"
  exitusage
fi

TODAY=$(date "+%Y%m%d%H%M")
IN_FILENAME=$1
HOME_DIR="/home"
OUT_FILENAME=${IN_FILENAME}_${TODAY}_del.csv

if [ ! -f ${IN_FILENAME} ] ; then
  echo "File not found"
  exit
fi

sudo touch ${OUT_FILENAME}

for USERDETAILS in $(cat ${IN_FILENAME}|cut -d\: -f1)
do
  MYUSER=$(echo ${USERDETAILS})
  echo "...Processing deleting user ${MYUSER}"
  if [ ! -z "$(getent passwd ${MYUSER})" ] ; then
    sudo userdel -r ${MYUSER} 
    sudo echo "${MYUSER}:deleted" >> ${OUT_FILENAME}
  else
    sudo echo "${MYUSER}:invalid" >> ${OUT_FILENAME}
  fi
done
sudo chmod go-rwx ${OUT_FILENAME}
sudo rm -f ${IN_FILENAME}
echo "Finished, the original filename ${IN_FILENAME} replaced with ${OUT_FILENAME} consists of lines with username:status format."
#END
